module Model.ServerExceptions where

import Control.Exception


data QueryException = SyntaxException |
                      VariableException | 
                      ParseFragmentException | 
                      EmptyQueryException | 
                      InvalidObjectException | 
                      InvalidScalarException |
                      InvalidObjectNestedObjectFieldException | 
                      InvalidObjectScalarFieldException | 
                      InvalidObjectSubFieldException |
                      InvalidAttributeTransformation |
                      NullArgumentException |
                      CreatingSqlQueryObjectFieldsException |
                      CreatingSqlQueryObjectsException |
                      TooManyTablesException |
                      EmptyRowException |
                      EOFDataProcessingException |
                      InvalidArgumentException |
                      Foundlinebreakexception |
                      RelationshipConfigurationException |
                      FailedObjectEqualityException |
                      DuplicateRootObjectsException |
                      ImportSchemaException |
                      ImportSchemaServerNameException |
                      ImportSchemaPseudonymsException |
                      ImportSchemaScalarFieldsException |
                      ImportSchemaObjectFieldsException |
                      ImportSchemaDatabaseTablesException |
                      ImportSchemaDatabaseRelationshipsException |
                      MissingVariableValueException |
                      InvalidVariableNameException |
                      MismatchedVariableTypeException |
                      InvalidVariableTypeException |
                      ReadVariablesException |
                      VariablesSyntaxException |
                      ValueInterpretationException
  deriving Show

instance Exception QueryException